<template>
  <div class="animation_dialog register">
    <el-dialog
      v-model="showRegisterDialog"
      destroy-on-close
      width="100%"
      custom-class="animation-dialog register-dialog"
      :show-close="false"
    >
      <div
        class="place-content-center font-medium fc-text3 w-full fixed z-10 register-dialog-header"
      >
        <div class="flex-auto text-base font-medium fc-text3 pl-2  flex justify-center">
          {{ $t("joinnow") }}
        </div>
        <div class="mr-4" @click="toggleLoginRegisterDialog(false)">
          <svg-icon
            svg-name="icon-x-stroke"
            class-name="h-5 w-5"
            style="fill: var(--text3)"
          />
        </div>
      </div>
      <!-- <template #title>
        <div class="flex-auto font-medium fc-text3 pl-2">
          <span class="text-base font-medium fc-text3 login-text-color">
            {{ $t("joinnow") }}
          </span>
        </div>
      </template> -->
      <div class="py-8 px-2 bg-1 min-h-screen register-dialog-container">
        <el-form
          ref="formRef"
          label-position="top"
          :rules="formRules"
          :model="formModel"
        >
          <el-form-item
            :class="{ required: rules.Username.required }"
            :label="$t('username')"
            prop="Username"
          >
            <el-input
              v-model="formModel.Username"
              :placeholder="$t('username')"
            />
          </el-form-item>
          <el-form-item
            :class="{ required: rules.Password.required }"
            :label="$t('password')"
            prop="Password"
          >
            <el-input
              v-model="formModel.Password"
              :type="inputTypePw"
              :placeholder="$t('password')"
            >
              <template #suffix>
                <div @click.prevent="showPassword('password')">
                  <font-awesome-icon v-if="isShowPassword" icon="eye-slash" />
                  <font-awesome-icon v-else icon="eye" />
                </div>
              </template>
            </el-input>
          </el-form-item>
          <el-form-item
            :class="{ required: rules.ConfirmPassword.required }"
            :label="$t('confirm_password')"
            prop="ConfirmPassword"
            show-password
          >
            <el-input
              v-model="formModel.ConfirmPassword"
              :type="inputTypecfPw"
              :placeholder="$t('confirm_password')"
            >
              <template #suffix>
                <div @click.prevent="showPassword('cfpassword')">
                  <font-awesome-icon v-if="isShowcfPassword" icon="eye-slash" />
                  <font-awesome-icon v-else icon="eye" />
                </div>
              </template>
            </el-input>
          </el-form-item>
          <el-form-item
            :class="{ required: rules.Currency.required }"
            :label="$t('currency')"
            prop="Currency"
          >
            <el-select
              v-model="formModel.Currency"
              style="width: 100%"
              :placeholder="$t('select_currency')"
              :disabled="currencies.length <= 0"
              class="register-selected-currency"
            >
              <el-option
                v-for="currency in currencies"
                :key="currency"
                :value="String(currency.Currency)"
              >
                <div class="flex justify-between w-full">
                  <div class="flex items-center">
                    <div>
                      {{ currency.Currency }}
                    </div>
                    <div class="w-[16px] ml-[11px] currency-check-icon">
                      <font-awesome-icon icon="circle-check" />
                    </div>
                  </div>
                </div>
              </el-option>
            </el-select>
          </el-form-item>
          <template
            v-for="property in availableProperties"
            :key="property.PropertyName"
          >
            <theme-common-otp-field
              v-if="property.PropertyName === 'Phone'"
              v-model="formModel"
              :label="property.PropertyNameForDisplay"
              :phone-property="property.PropertyName"
              :is-required="rules[property.PropertyName].required"
              :loading="isGettingOtpCode"
              :next-request-in-seconds="nextRequestOtpInSeconds"
              @get-code="onGetVerificationCode"
            ></theme-common-otp-field>
            <el-form-item
              v-else
              :label="property.PropertyNameForDisplay"
              :prop="property.PropertyName"
              :class="{ required: rules[property.PropertyName].required }"
            >
              <el-select
                v-if="property.PropertyName === 'Bank'"
                v-model="formModel.Bank"
                style="width: 100%"
                :placeholder="$t('select_bank')"
                :disabled="bankOptions.length <= 0"
              >
                <el-option
                  v-for="bank in bankOptions"
                  :key="bank.Id"
                  :label="bank.BankName"
                  :value="String(bank.Id)"
                >
                  <div class="flex justify-between w-full">
                    <div class="flex items-center">
                      <div>
                        {{ bank.BankName }}
                      </div>
                      <div class="w-[16px] ml-[11px] bank-check-icon">
                        <font-awesome-icon icon="circle-check" />
                      </div>
                    </div>
                  </div>
                </el-option>
              </el-select>
              <div v-else-if="property.PropertyName === 'Gender'">
                <el-radio v-model="formModel.Gender" label="male">{{
                  $t("male")
                }}</el-radio>
                <el-radio v-model="formModel.Gender" label="female">{{
                  $t("female")
                }}</el-radio>
              </div>
              <el-date-picker
                v-else-if="property.PropertyName === 'DateOfBirth'"
                v-model="formModel.DateOfBirth"
                type="date"
                value-format="YYYY-MM-DD"
                :popper-class="isBK8 ? 'register-date' : ''"
                :class="isBK8 ? 'register-date-input' : ''"
              />
              <el-input
                v-else-if="property.PropertyName === 'Mobile'"
                v-model="formModel[property.PropertyName]"
                :placeholder="$t('mobile')"
                :formatter="(value: string) => value"
                :parser="(value: string) => value.replace(/\D+/g, '')"
              ></el-input>
              <el-input
                v-else-if="property.PropertyName === 'Phone'"
                v-model="formModel[property.PropertyName]"
                :placeholder="property.PropertyName"
                :formatter="(value: string) => value"
                :parser="(value: string) => value.replace(/\D+/g, '')"
              >
                <template #suffix>
                  <el-tooltip
                    class="box-item"
                    effect="dark"
                    :content="
                      $t(
                        'valid_mobile_number_is_required_for_deposit_and_withdrawal_verification_purposes'
                      )
                    "
                    placement="bottom"
                  >
                    <el-icon class="el-input__icon info" color="var(--primary)">
                      <info-filled />
                    </el-icon>
                  </el-tooltip>
                </template>
              </el-input>
              <el-input
                v-else-if="property.PropertyName === 'Referral'"
                v-model="formModel[property.PropertyName]"
                :disabled="referralQuery.length"
                :placeholder="$t('referral')"
              ></el-input>
              <el-input
                v-else-if="property.PropertyName === 'BankAccountName'"
                v-model="formModel[property.PropertyName]"
                :placeholder="property.PropertyNameForDisplay"
                :disabled="formModel.Bank === '0' || formModel.Bank === ''"
              ></el-input>
              <el-input
                v-else-if="property.PropertyName === 'BankAccountNumber'"
                v-model="formModel[property.PropertyName]"
                :placeholder="property.PropertyNameForDisplay"
                :disabled="formModel.Bank === '0' || formModel.Bank === ''"
                :formatter="(value: string) => value" :parser="(value: string) => value.replace(/\D+/g, '')"
              ></el-input>
              <el-input
                v-else
                v-model="formModel[property.PropertyName]"
                :placeholder="property.PropertyNameForDisplay"
              ></el-input>
            </el-form-item>
          </template>
          <el-form-item
            v-if="cashAgentQuery.length"
            :label="$t('agent_name')"
            prop="AgentName"
          >
            <el-input
              v-model="formModel.AgentName"
              :disabled="cashAgentQuery.length"
            />
          </el-form-item>
          <el-form-item
            v-if="!reCaptcha.IsHidden && reCaptchaSiteKey !== ''"
            :class="[isVerified ? 'verify__recaptcha__success' : '']"
            prop="Recaptcha"
          >
            <re-captcha
              id="registerCaptcha"
              :sitekey="reCaptchaSiteKey"
              :load-recaptcha-script="true"
              @verify="onVerify"
              @error="onRecaptchaError"
              @expired="onRecaptchaError"
            ></re-captcha>
          </el-form-item>
          <el-form-item v-if="!clientCaptcha.IsHidden" prop="Captcha">
            <div class="captcha">
              <captcha
                :value="formModel.Captcha"
                @isValid="getCaptchaErrorMsg"
              />
              <el-input
                id="registerCaptchaValidationCode"
                v-model="formModel.Captcha"
                type="text"
                :placeholder="$t('enter_validation_code')"
              />
            </div>
          </el-form-item>
          <template class="flex justify-center">
            <div class="mt-5">
              <el-button
                :loading="isLoading"
                type="primary"
                round
                @click="onRegister(formRef)"
                >{{ $t("submit") }}</el-button
              >
            </div>
          </template>
        </el-form>
      </div>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from "vue";
// import { VueRecaptcha } from "vue-recaptcha";
import useRegister from "@/composables/useRegister";
import { store } from "@/store";

export default defineComponent({
  components: {
    // reCaptcha: VueRecaptcha,
  },
  setup() {
    const { toggleLoginRegisterDialog } = commonHelper;
    const showRegisterDialog = computed(() => store.state.showRegisterDialog);
    const inputTypePw = ref("password");
    const inputTypecfPw = ref("password");
    const isShowPassword = ref(false);
    const isShowcfPassword = ref(false);
    const showPassword = (input: string) => {
      if (input === "password" && inputTypePw.value === "text") {
        inputTypePw.value = "password";
        isShowPassword.value = false;
      } else if (input === "password" && inputTypePw.value === "password") {
        inputTypePw.value = "text";
        isShowPassword.value = true;
      } else if (input === "cfpassword" && inputTypecfPw.value === "text") {
        inputTypecfPw.value = "password";
        isShowcfPassword.value = false;
      } else {
        inputTypecfPw.value = "text";
        isShowcfPassword.value = true;
      }
    };
    const themeName = store.state.selectedThemeName;
    const isMain = computed(() => store.state.selectedThemeName === "main");
    const {
      availableProperties,
      bankOptions,
      currencies,
      formModel,
      formRef,
      formRules,
      onRegister,
      getCaptchaErrorMsg,
      clientCaptcha,
      reCaptcha,
      reCaptchaSiteKey,
      onVerify,
      onRecaptchaError,
      isVerified,
      cashAgentQuery,
      referralQuery,
      isLoading,
      rules,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
    } = useRegister();
    const isBK8 =
      store.state.companyThemePropertiesFromApi.ThemeProperties.find(
        (p) => p.HtmlId === "theme_color" && p.Text.toLowerCase() === "bk8"
      );
    return {
      availableProperties,
      bankOptions,
      currencies,
      formModel,
      formRef,
      formRules,
      onRegister,
      getCaptchaErrorMsg,
      clientCaptcha,
      reCaptcha,
      reCaptchaSiteKey,
      onVerify,
      onRecaptchaError,
      isVerified,
      cashAgentQuery,
      referralQuery,
      showRegisterDialog,
      isShowcfPassword,
      isShowPassword,
      inputTypePw,
      inputTypecfPw,
      showPassword,
      isLoading,
      rules,
      isBK8,
      toggleLoginRegisterDialog,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
      themeName,
      isMain,
    };
  },
});
</script>

<style scoped lang="scss">
.el-form-item.is-error.verify__recaptcha__success
  > :where(.el-form-item__content)
  > :deep(.el-form-item__error) {
  display: none;
}
:deep(.el-dialog__headerbtn .el-dialog__close) {
  color: var(--text5);
}
:deep(.el-dialog__headerbtn) {
  top: 2px;
}
:deep(.el-form--label-top) {
  @apply mt-8;
}
:deep(.el-dialog__header) {
  display: none;
  background: var(--background3);
  border-bottom: 1px solid var(--background4);
  margin-right: 0px;
  padding: 16px;
}
.svg-inline--fa {
  color: var(--text);
}
.selected {
  color: var(--hint) !important;
}
:deep(.el-input__inner) {
  background-color: var(--background1);
  height: 48px !important;
  border-radius: 8px;

  &:-webkit-autofill {
    -webkit-background-clip: text;
    -webkit-text-fill-color: var(--text);
  }
}
.bg-1 {
  background-color: var(--background2);
}
.el-button.el-button--primary {
  --el-button-text-color: var(--textBtn);
  --el-button-bg-color: rgb(49, 196, 110);
  --el-button-border-color: rgb(49, 196, 110);
  --el-button-hover-text-color: var(--textBtn);
  --el-button-hover-bg-color: rgb(107, 82, 203);
  --el-button-hover-border-color: rgb(107, 82, 203);
}
.el-input {
  --el-input-focus-border-color: rgb(49, 196, 110);
}
.text-primary {
  color: var(--primary);
}
:deep(button.el-button) {
  width: 142px !important;
  height: 40px !important;
  background-color: var(--primary);
  border: none;
}
:deep(.el-button span) {
  @apply text-sm font-bold leading-4;
}
.selected .currency-check-icon {
  display: block;
}
.currency-check-icon {
  display: none;
}
.selected .bank-check-icon {
  display: block;
}
.bank-check-icon {
  display: none;
}
.captcha {
  width: 100%;
}
.vue_client_recaptcha {
  height: 65px;
  margin-bottom: 18px;
}
:deep(.vue_client_recaptcha_icon) {
  width: 50%;
  height: 100%;
}
:deep(.vue_client_recaptcha .captcha_canvas) {
  width: 100%;
}
:deep(.el-input__suffix) {
  @apply flex items-center;
}
[theme-color="bk8"] .info {
  color: var(--success);
}
[theme-color="bk8"] .animation_dialog.register .title {
  color: var(--text5);
}
[theme-color="global_light_01"] .register-text-color,
.svg-inline--fa.fa-x {
  color: var(--text3);
}
.register-dialog-header {
  display: flex;
  height: 52px;
  justify-content: space-between;
  align-items: center;
  background: var(--background3);

  &:after {
    content: "";
    position: absolute;
    bottom: 0;
    width: 100%;
    height: 1px;
    background: var(--background4);
  }

  .el-dialog__headerbtn {
    position: unset;
    width: 24px;
    height: 24px;
    padding-right: 16px;
    display: flex;
    justify-content: center;
    align-items: center;
  }
}
</style>
<style>
[theme-color="bk8"] .register-selected-currency {
  font-weight: bold;
}
[theme-color="bk8"] .register-selected-currency input::placeholder {
  font-weight: normal;
}
.el-popper.register-date {
  background-color: var(--background1);
}
[theme-color="bk8"] .register-date-input .el-input__prefix {
  z-index: 1;
}
[theme-color="bk8"] .register-date-input .el-input__prefix .el-icon svg path {
  fill: black;
  stroke-width: 46px;
}
</style>
